/* Copyright (C) 2020  C. McEnroe <june@causal.agency>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <assert.h>
#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <wchar.h>

#include "chat.h"

enum { Cap = 512 };
static wchar_t buf[Cap] = L"foo\0033bar\3baz";
static size_t len = 12;
static size_t pos = 6;

const char *editHead(void) {
	static char mbs[MB_LEN_MAX * Cap];
	const wchar_t *ptr = buf;
	size_t n = wcsnrtombs(mbs, &ptr, pos, sizeof(mbs), NULL);
	assert(n != (size_t)-1);
	return mbs;
}

const char *editTail(void) {
	static char mbs[MB_LEN_MAX * Cap];
	const wchar_t *ptr = &buf[pos];
	size_t n = wcsnrtombs(mbs, &ptr, len - pos, sizeof(mbs), NULL);
	assert(n != (size_t)-1);
	return mbs;
}
